local utils = require 'utils'
local errType = require 'errType'

local Disks_Unmount = {}

function Disks_Unmount.invoke(args)
    local path;

    if args ~= nil then
        if utils.isArray(args) then
            if #args >= 1 then
                path = args[1]
            end
        else
            path = args.path
        end
    end

    if path == nil or type(path) ~= 'string' then
        return nil, errType.codes.InvalidParams, {message = 'Failed to read parameter \'path\'.'}
    end

    local _, err, errData = utils.shell_posix('sudo', nil, 'umount', path)
    if err ~= nil then
        return nil, err, errData
    end
end

return Disks_Unmount
