local errType = require 'errType'
local utils = require 'utils'

local FileSystem_Remove = {}

function FileSystem_Remove.invoke(args)
    local path

    if args ~= nil then
        if utils.isArray(args) then
            if #args >= 1 then
                path = args[1]
            end
        else
            path = args.path
        end
    end

    if path == nil or type(path) ~= 'string' then
        return nil, errType.codes.InvalidParams, {message = 'Failed to read parameter \'path\'.'}
    end

    local writable, err, errData = utils.isPathWritable(path)
    if writable ~= true then
        return nil, err, errData
    end

    local _
    _, err, errData = utils.shell_posix('rm', nil, '-r', path)
    if err ~= nil then
        return nil, err, errData
    end
end

return FileSystem_Remove
