local utils = require 'utils'
local cjson = require 'cjson.safe'
local errType = require 'errType'

local RexArc_Scan = {}

function RexArc_Scan.invoke()
    local out, err, errData = utils.shell_posix('RexArc', nil, '--scan')
    if err ~= nil then
        return nil, err, errData
    end

    local data = cjson.decode(out)

    if data == nil or type(data) ~= 'table' then
        return nil, errType.codes.InternalError,
        {message = 'Failed to parse output of RexArc to JSON.'}
    end
    return data
end

return RexArc_Scan
