local errType = require 'errType'
local utils = require 'utils'

local System_Shutdown = {}

function System_Shutdown.invoke(args)

    local action = nil

    if args ~= nil then
        if utils.isArray(args) and #args == 1 then
            action = args[1]
        else
            action = args.action
        end
    end

    local valid = false
    if type(action) == 'string' and (action == 'poweroff' or action == 'reboot') then
        valid = true
    end
    if valid == false then
        return nil, errType.codes.InvalidParams, {message = 'Parameter \'action\' is invalid.'}
    end

    if action == 'poweroff' then
        local _, err = utils.shell_posix('sudo', nil, 'systemctl', 'poweroff')
        if err ~= nil then
            local errData
            _, err, errData = utils.shell_posix('sudo', nil, 'poweroff')
            if err ~= nil then
                return nil, err, errData
            end
        end
    else
        local _, err = utils.shell_posix('sudo', nil, 'systemctl', 'reboot')
        if err ~= nil then
            local errData
            _, err, errData = utils.shell_posix('sudo', nil, 'reboot')
            if err ~= nil then
                return nil, err, errData
            end
        end
    end
end

return System_Shutdown
