local errType = require 'errType'
local utils = require 'utils'

local TimeDate_GetUptime = {}

function TimeDate_GetUptime.invoke()
    local content = utils.readFromFile('/proc/uptime')
    if content == nil then
        return nil, errType.codes.ServerError, {message = 'Failed to read content from path \'/proc/uptime\'.'}
    end

    local uptime = {}
    local up, idle = string.match(content, '(%d+%.%d+)%s+(%d+%.%d+)')
    if up ~= nil then
        uptime.up = tonumber(up)
    end
    if idle ~= nil then
        uptime.idle = tonumber(idle)
    end

    local stdout, err, errData = utils.shell_posix('date', nil, '+%F %T')
    if err ~= nil then
        return nil, err, errData
    end
    uptime.localTime = stdout

    return uptime
end

return TimeDate_GetUptime
